/*
 Téléversez et démarrez l'étallonage SANS masse sur la balance
 Une fois les lectures affichées, placez une masse de référence sur la balance
 Appuyez sur +/- ou a / z pour régler le facteur d'étalonnage jusqu'à ce que les lectures de sortie correspondent à la masse de référence
 Arduino pin 6 -> HX711 CLK
 Arduino pin 5 -> HX711 DOUT
 Arduino pin 5V -> HX711 VCC
 Arduino pin GND -> HX711 GND 
*/

#include "HX711.h"

HX711 scale(5, 6);

float calibration_factor = -377; // ce facteur dépend du capteur fore utilisé
float units;
float ounces;

void setup() {
  Serial.begin(9600);
  Serial.println("Etalonnage");
  Serial.println("Retirer toute masse de la balance");
  Serial.println("Après début des mesures, placer une masse de référence sur la balnce");
  Serial.println("Appuyez + ou a pour augmenter le coefficient");
  Serial.println("Appuyez - or z pour diminuer le coefficient");

  scale.set_scale();
  scale.tare();  //Reset the scale to 0

  long zero_factor = scale.read_average(); //Get a baseline reading
  Serial.print("Zero factor: "); //This can be used to remove the need to tare the scale. Useful in permanent scale projects.
  Serial.println(zero_factor);
}

void loop() {

  scale.set_scale(calibration_factor); //Adjust to this calibration factor

  Serial.print("Reading: ");
  units = scale.get_units(), 10;
  if (units < 0)
  {
    units = 0.00;
  }
  ounces = units * 0.035274;
  Serial.print(units);
  Serial.print(" grams"); 
  Serial.print(" calibration_factor: ");
  Serial.print(calibration_factor);
  Serial.println();

  if(Serial.available())
  {
    char temp = Serial.read();
    if(temp == '+' || temp == 'a')
      calibration_factor += 1;
    else if(temp == '-' || temp == 'z')
      calibration_factor -= 1;
  }
}
