//
//     Vitesse des ultrasons
//
  float distance = 0.3;       // Valeur de la distance entre l'émetteur-récepteur et l'obstacle en mètre
  float duree;                // Déclare des variables de type "virgule flottante" 
  float vitesse;                  //appelée duree et vitesse.
  int Pin_Trig=2;             // Sélectionne la broche 2 pour être reliée à l'entrée Trigger du capteur ultrason HC-SR04.
  int Pin_Echo=3;             // Sélectionne la broche 3 pour être reliée à la sortie Echo du HC-SR04.
  
void setup()                // Initialisation du programme
{
    pinMode(Pin_Trig, OUTPUT);  // Configure la broche Pin_Trig en sortie.
    pinMode(Pin_Echo,INPUT);    // Configure la broche Pin_Echo en entrée.
    Serial.begin(9600);         // Initialise la vitesse de communication entre la carte Plug'Uino et le PC 9600 bps.
   
    }
void loop()               // Boucle principale
{
    digitalWrite(Pin_Trig, HIGH);
    delayMicroseconds(5);                  // Une impulsion High (5 V) de 5 µs (le minimum est 2 µs) est envoyée sur la broche Trigger du capteur.
    digitalWrite(Pin_Trig,LOW);            // Le capteur génère alors une salve d'ultrasons à 40 kHz pendant 200µs (soit 8 périodes de 25 µs).
     
    duree = pulseIn(Pin_Echo,HIGH)*1e-6 ;  // Le capteur attend le retour du signal réfléchi et lorsqu'il le détecte, la sortie echo envoie une impulsion de 5 V dont la durée
                                               //est égale à la durée d'un aller-retour de la salve.
                                           // pulseIn mesure la durée (en µs) de l'impulsion (le chronométrage commence lorsque la broche Pin_Echo passe au niveau haut et s'arrête
                                               //lorsqu'elle repasse au niveau bas).               
  vitesse = distance*2/duree ;             // Calcule la vitesse qui correspond au rapport de la distance parcourue par l'onde (soit le double de la distance
                                              //entre le capteur et l'obstacle) par la durée d'un aller-retour.
  Serial.print("La vitesse est de ");     // Affiche la phrase entre guillements.
  Serial.print(vitesse);                  // Affiche la vitesse.
  Serial.println(" m/s");                 // Affiche l'unité, et passe à la ligne.
  delay(1000);                            // Attend 1000 ms avant de recommencer.
}
